import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import bc1_1
import bgb4

def Execute (names, dictionaries):
	global variables
	global params
	global bc1_1_p
	global bgb4_p

	bc1_1.variables = variables
	bgb4.variables = variables

	params = variables['PARAM_NG_a_bgb5']
	bc1_1_p = variables['PARAM_NG_bc1_1']
	bgb4_p = variables['PARAM_NG_bgb4']

	## use the following variable to use bc1_1  position
	#VISIGeoLib.ProjectPointOntoVector(bc1_1_p['POSITION'], bc1_1_p['DIRECTION'], params['OFFSET_BALLCAGE'], bc1_1_p['POSITION'])
	bc1_1_pos = bc1_1_p['POSITION']
	
	#Calculate correct diameter Drilling
	bc1_1_p['CLEARENCE_DIAMETER']= bc1_1_p['CLEARENCE_DIAMETER'] + (bgb4_p['DIAMETER_EXT']-bgb4_p['DIAMETER_INT'])
	
	## use the following variable to use bc1_1  direction
	bc1_1_dir = bc1_1_p['DIRECTION']

	## uncomment following line to disable bc1_1 cavity building
	## bc1_1_p['BUILD_CAVITY'] = 0
	bc1_1.key_name = 'PARAM_NG_bc1_1'
	bc1_1.Execute(names, dictionaries)
	## use the following line to put bc1_1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
	
	if bc1_1_p['INVERT_ELEMENT']:
		VISIGeoLib.ProjectPointOntoVector(bgb4_p['POSITION'], bgb4_p['DIRECTION'], -bc1_1_p['PLATE_THICK']+bgb4_p['LENGTH'], bgb4_p['POSITION'])

	## use the following variable to use bgb4  position
	VISIGeoLib.ProjectPointOntoVector(bgb4_p['POSITION'], bgb4_p['DIRECTION'], params['OFFSET_BUSH'], bgb4_p['POSITION'])
	
	bgb4_pos = bgb4_p['POSITION']
	## use the following variable to use bgb4  direction
	bgb4_dir = bgb4_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable bgb4 cavity building
	bgb4_p['BUILD_CAVITY'] = 0
	bgb4.key_name = 'PARAM_NG_bgb4'
	bgb4.Execute(names, dictionaries)
	## use the following line to put bgb4 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
