import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, VISIParam
variables = 0
params = 0
import csc1
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global csc1_p
	global shcs1_p

	csc1.variables = variables
	shcs1.variables = variables

	params = variables['PARAM_NG_a_csc1']
	csc1_p = variables['PARAM_NG_csc1']
	shcs1_p = variables['PARAM_NG_shcs1']

	## use the following variable to use csc1  position
	csc1_pos = csc1_p['POSITION']
	## use the following variable to use csc1  direction
	csc1_dir = csc1_p['DIRECTION']

	## uncomment following line to disable csc1 cavity building
	## csc1_p['BUILD_CAVITY'] = 0
	csc1.key_name = 'PARAM_NG_csc1'
	csc1.Execute(names, dictionaries)
	
	csc1_cavity = dictionaries[ dictionaries.__len__()-1]['CAVITY_TAG']
	## use the following line to put csc1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcs1  position
	shcs1_pos = shcs1_p['POSITION']
	## use the following variable to use shcs1  direction
	shcs1_dir = shcs1_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable shcs1 cavity building
	shcs1_p['BUILD_CAVITY'] = 0
	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
	index_shcs1 = dictionaries.__len__()-1
	## use the following line to put shcs1 cavity
	start_screw_cavity = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
	start_screw_cavity = VISIParam.AdaptCavityToPlate(csc1_cavity, start_screw_cavity, 1)
	dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity

	return 0
