import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import desc1
import esc1

def Execute (names, dictionaries):
	global variables
	global params
	global desc1_p
	global esc1_p

	desc1.variables = variables
	esc1.variables = variables

	params = variables['PARAM_NG_a_desc1']
	desc1_p = variables['PARAM_NG_desc1']
	esc1_p = variables['PARAM_NG_esc1']

	## use the following variable to use desc1  position
	desc1_pos = desc1_p['POSITION']
	## use the following variable to use desc1  direction
	desc1_dir = desc1_p['DIRECTION']

	## uncomment following line to disable desc1 cavity building
	## desc1_p['BUILD_CAVITY'] = 0
	desc1.key_name = 'PARAM_NG_desc1'
	desc1.Execute(names, dictionaries)
	## use the following line to put desc1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use esc1  position
	#esc1_pos = esc1_p['POSITION']
	## use the following variable to use esc1  direction
	#esc1_dir = esc1_p['DIRECTION']

	## put additional member contraints

	
	## uncomment following line to disable esc1 cavity building
	esc1_p['BUILD_CAVITY'] = 0
	esc1.key_name = 'PARAM_NG_esc1'
	esc1.Execute(names, dictionaries)
	
	
	
	## use the following line to put esc1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
