import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import es4
import wes1

def Execute (names, dictionaries):
	global variables
	global params
	global es4_p
	global wes1_p

	es4.variables = variables
	wes1.variables = variables

	params = variables['PARAM_NG_a_es4']
	es4_p = variables['PARAM_NG_es4']
	wes1_p = variables['PARAM_NG_wes1']

	## use the following variable to use es4  position
	es4_pos = es4_p['POSITION']
	## use the following variable to use es4  direction
	es4_dir = es4_p['DIRECTION']

	
	
	## uncomment following line to disable es4 cavity building
	## es4_p['BUILD_CAVITY'] = 0
	es4.key_name = 'PARAM_NG_es4'
	es4.Execute(names, dictionaries)
	## use the following line to put es4 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	
	
	## use the following variable to use wes1  position
	wes1_pos = wes1_p['POSITION']
	## use the following variable to use wes1  direction
	wes1_dir = wes1_p['DIRECTION']
	## put additional member contraints
	## uncomment following line to disable wes1 cavity building
	## wes1_p['BUILD_CAVITY'] = 0
	if  params['BUILD_WASHER'] == 1:
		wes1.key_name = 'PARAM_NG_wes1'
		wes1.Execute(names, dictionaries)
	## use the following line to put wes1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
