import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import llcp3
import llcp1_1
import llcp1_4
import llcp1_5
import llcp1_6
import llcp3_7
import llcp3_5
import llcp3_6
import shcs1


def Execute (names, dictionaries):
	global variables
	global params
	global llcp3_p
	global llcp1_1_p
	global llcp1_4_p
	global llcp1_5_p
	global llcp1_6_p
	global llcp3_7_p
	global llcp3_5_p
	global llcp3_6_p
	global shcs1_p
	global shcs1_1_p

	llcp3.variables = variables
	llcp1_1.variables = variables
	llcp1_4.variables = variables
	llcp1_5.variables = variables
	llcp1_6.variables = variables
	llcp3_7.variables = variables
	llcp3_5.variables = variables
	llcp3_6.variables = variables
	shcs1.variables = variables

	params = variables['PARAM_NG_a_llcp3']
	llcp3_p = variables['PARAM_NG_llcp3']
	llcp1_1_p = variables['PARAM_NG_llcp1_1']
	llcp1_4_p = variables['PARAM_NG_llcp1_4']
	llcp1_5_p = variables['PARAM_NG_llcp1_5']
	llcp1_6_p = variables['PARAM_NG_llcp1_6']
	llcp3_7_p = variables['PARAM_NG_llcp3_7']
	llcp3_5_p = variables['PARAM_NG_llcp3_5']
	llcp3_6_p = variables['PARAM_NG_llcp3_6']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']
	
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(llcp3_p['DIRECTION'], llcp3_p['REF_DIRECTION'], y_axis)

	llcp3.key_name = 'PARAM_NG_llcp3'
	llcp3.Execute(names, dictionaries)

	index_llcp1_0 = dictionaries.__len__()-1
	element_llcp1_0 = dictionaries[index_llcp1_0]['ELEM_TAG']

	
	if llcp1_1_p['TYPE'] == llcp3_p['TYPE'] and llcp1_1_p['SUB_TYP'] == llcp3_p['SUB_TYP'] and llcp1_1_p['SUB_SUB_TYP'] == llcp3_p['SUB_SUB_TYP']:
		
		llcp1_1.key_name = 'PARAM_NG_llcp1_1'
		llcp1_1.Execute(names, dictionaries)
	
		index_llcp1_1_0 = dictionaries.__len__()-1
		element_llcp1_1_0 = dictionaries[index_llcp1_1_0]['ELEM_TAG']

	if llcp1_4_p['TYPE'] == llcp3_p['TYPE'] and llcp1_4_p['SUB_TYP'] == llcp3_p['SUB_TYP'] and llcp1_4_p['SUB_SUB_TYP'] == llcp3_p['SUB_SUB_TYP']:

		##1
		llcp1_4.key_name = 'PARAM_NG_llcp1_4'
		llcp1_4.Execute(names, dictionaries)
		
		##2
		VISIGeoLib.ProjectPointOntoVector(llcp1_4_p['POSITION'], y_axis, -llcp1_4_p['LENGTH']-2*0.1/1000-llcp3_7_p['WIDTH5'], llcp1_4_p['POSITION'])
		
		llcp1_4.key_name = 'PARAM_NG_llcp1_4'
		llcp1_4.Execute(names, dictionaries)
		
		
		VISIGeoLib.ProjectPointOntoVector(llcp1_4_p['POSITION'], llcp3_p['REF_DIRECTION'], 36./1000, llcp1_4_p['POSITION'])
		
		llcp1_4.key_name = 'PARAM_NG_llcp1_4'
		llcp1_4.Execute(names, dictionaries)
		
		## put additional member contraints
		VISIGeoLib.ProjectPointOntoVector(llcp1_4_p['POSITION'], y_axis, -(-llcp1_4_p['LENGTH']-2*0.1/1000-llcp3_7_p['WIDTH5']), llcp1_4_p['POSITION'])
		
		llcp1_4.key_name = 'PARAM_NG_llcp1_4'
		llcp1_4.Execute(names, dictionaries)

	if llcp1_5_p['TYPE'] == llcp3_p['TYPE'] and llcp1_5_p['SUB_TYP'] == llcp3_p['SUB_TYP'] and llcp1_5_p['SUB_SUB_TYP'] == llcp3_p['SUB_SUB_TYP']:

		llcp1_5.key_name = 'PARAM_NG_llcp1_5'
		llcp1_5.Execute(names, dictionaries)

	if llcp1_6_p['TYPE'] == llcp3_p['TYPE'] and llcp1_6_p['SUB_TYP'] == llcp3_p['SUB_TYP'] and llcp1_6_p['SUB_SUB_TYP'] == llcp3_p['SUB_SUB_TYP']:

		llcp1_6.key_name = 'PARAM_NG_llcp1_6'
		llcp1_6.Execute(names, dictionaries)

	if llcp3_7_p['TYPE'] == llcp3_p['TYPE']:

		llcp3_7.key_name = 'PARAM_NG_llcp3_7'
		llcp3_7.Execute(names, dictionaries)
		
		
	if llcp3_5_p['TYPE'] == llcp3_p['TYPE'] and llcp3_5_p['SUB_TYP'] == llcp3_p['SUB_TYP'] and llcp3_5_p['SUB_SUB_TYP'] == llcp3_p['SUB_SUB_TYP']:

		llcp3_5.key_name = 'PARAM_NG_llcp3_5'
		llcp3_5.Execute(names, dictionaries)


	if llcp3_6_p['TYPE'] == llcp3_p['TYPE'] and llcp3_6_p['SUB_TYP'] == llcp3_p['SUB_TYP'] and llcp3_6_p['SUB_SUB_TYP'] == llcp3_p['SUB_SUB_TYP']:

		llcp3_6.key_name = 'PARAM_NG_llcp3_6'
		llcp3_6.Execute(names, dictionaries)

		

	# Screw Screws

	shcs1_p['START_THICK'] = llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_SINK1']
	shcs1_p['END_THICK'] = 100./1000
	shcs1_p['TOTAL_THICK'] = llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_SINK1']+100./1000
	## 1
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, llcp1_6_p['LENGTH6']/2, shcs1_p['POSITION'])
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], llcp1_6_p['DIRECTION'], llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_LOW']-llcp1_6_p['HEIGHT_SINK1'], shcs1_p['POSITION'])
	
	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
	
	##2
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, -llcp1_6_p['LENGTH6'], shcs1_p['POSITION'])
	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
	
	##3
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], llcp3_p['REF_DIRECTION'], params['LENGTH6'], shcs1_p['POSITION'])
	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
	
	##4
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, llcp1_6_p['LENGTH6'], shcs1_p['POSITION'])
	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
				
	
	#Create 2 Screws for fixing Pos29 and Pos42
	
	shcs1_1_p['START_PLATE'] = element_llcp1_0
	shcs1_1_p['END_PLATE'] = 0
		
	##Set Y Position
	VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], y_axis,  llcp3_p['DISTANCE_BETWEEN_SCREWS']/2, shcs1_1_p['POSITION'])
	

	## 1
	shcs1_1_p['BUILD_CAVITY'] = 0
	shcs1.key_name = 'PARAM_NG_shcs1_1'
	shcs1.Execute(names, dictionaries)
	
	index_shcs1_1_1 = dictionaries.__len__()-1
	end_screw_cavity_1 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_1_1]['ELEM_TAG'])
	dictionaries[index_shcs1_1_1]['CAVITY_TAG'] = end_screw_cavity_1
	
	start_screw_cavity_1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_1_1]['ELEM_TAG'])
	
	#Correct Y Position
	VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], y_axis,  -llcp3_p['DISTANCE_BETWEEN_SCREWS'], shcs1_1_p['POSITION'])
	
	## 2
	shcs1_1_p['BUILD_CAVITY'] = 0
	shcs1.key_name = 'PARAM_NG_shcs1_1'
	shcs1.Execute(names, dictionaries)
	
	index_shcs1_1_2 = dictionaries.__len__()-1
	end_screw_cavity_2 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_1_2]['ELEM_TAG'])
	dictionaries[index_shcs1_1_2]['CAVITY_TAG'] = end_screw_cavity_2
	
	start_screw_cavity_2 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_1_2]['ELEM_TAG'])

	
	##Subtract Cavity for Plate
	Uni_List = []
	Result_List = []
	Uni_List.append(element_llcp1_0)
	Uni_List.append(start_screw_cavity_1)
	Uni_List.append(start_screw_cavity_2)
	VISISolidFactory.Subtract(Uni_List, Result_List)

	dictionaries[index_llcp1_0]['ELEM_TAG'] = Result_List[0]
	
	return 0
