import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import ls3
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global ls3_p
	global shcs1_p
	global shcs1_1_p

	ls3.variables = variables
	shcs1.variables = variables

	params = variables['PARAM_NG_a_ls3']
	ls3_p = variables['PARAM_NG_ls3']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']

	## use the following variable to use ls3  position
	ls3_pos = ls3_p['POSITION']
	## use the following variable to use ls3  direction
	ls3_dir = ls3_p['DIRECTION']

	## uncomment following line to disable ls3 cavity building
	## ls3_p['BUILD_CAVITY'] = 0
	ls3.key_name = 'PARAM_NG_ls3'
	ls3.Execute(names, dictionaries)
	## use the following line to put ls3 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	if params['SCREW_INSIDE']:
		## use the following variable to use shcs1  position
		shcs1_pos = shcs1_p['POSITION']
		## use the following variable to use shcs1  direction
		shcs1_dir = shcs1_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable shcs1 cavity building
		## shcs1_p['BUILD_CAVITY'] = 0
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		## use the following line to put shcs1 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	if params['SCREW_OUTSIDE']:
		## use the following variable to use shcs1_1  position
		shcs1_1_pos = shcs1_1_p['POSITION']
		## use the following variable to use shcs1_1  direction
		shcs1_1_dir = shcs1_1_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable shcs1_1 cavity building
		shcs1_1_p['BUILD_CAVITY'] = 0
		shcs1.key_name = 'PARAM_NG_shcs1_1'
		shcs1.Execute(names, dictionaries)
		index_shcs1_1 = dictionaries.__len__()-1
		end_screw_cavity_1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_1]['ELEM_TAG'])
		dictionaries[index_shcs1_1]['CAVITY_TAG'] = end_screw_cavity_1

	return 0
