import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import pcylaz1_4
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global pcylaz1_4_p
	global shcs1_p

	pcylaz1_4.variables = variables
	shcs1.variables = variables
	
	params = variables['PARAM_NG_a_pcylaz1_4']
	pcylaz1_4_p = variables['PARAM_NG_pcylaz1_4']
	shcs1_p = variables['PARAM_NG_shcs1']

        without_fixing = params['WITHOUT_FIXING']
	pcylaz1_4_pos = pcylaz1_4_p['POSITION']
	pcylaz1_4_dir = pcylaz1_4_p['DIRECTION']
	pcylaz1_4.key_name = 'PARAM_NG_pcylaz1_4'
	pcylaz1_4.Execute(names, dictionaries)
	index_pcylaz1_4 = dictionaries.__len__()-1
	pcylaz1_4_tag = dictionaries[index_pcylaz1_4]['ELEM_TAG']

	i=0

	if(not(without_fixing)):
		while i < pcylaz1_4_p['NSCREW']:
				shcs1_p['POSITION'] = pcylaz1_4.screw_positions[i]
				shcs1_p['BUILD_CAVITY'] = 0
				shcs1_p['key_name'] = 'shcs1'
				shcs1.Execute(names, dictionaries)
				index_shcs1 = dictionaries.__len__()-1
				start_screw_cavity = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
				end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
				i = i + 1
				dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity
				bool_list = []
				result_list = []
				bool_list.append(pcylaz1_4_tag)
				bool_list.append(end_screw_cavity)
				VISISolidFactory.Subtract(bool_list, result_list)
				## Assign the result of subtraction to column tag
				dictionaries[index_pcylaz1_4]['ELEM_TAG'] = result_list[0]
		else:
			return 0
	else:
		while i < pcylaz1_4_p['NSCREW']:
			shcs1_p['POSITION'] = pcylaz1_4.screw_positions[i]
			shcs1_p['BUILD_ELEM'] = 0
			shcs1_p['BUILD_CAVITY'] = 0
			shcs1_p['key_name'] = 'shcs1'
			shcs1.Execute(names, dictionaries)
			index_shcs1 = dictionaries.__len__()-1
			end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			i = i + 1
			bool_list = []
			result_list = []
			bool_list.append(pcylaz1_4_tag)
			bool_list.append(end_screw_cavity)
			VISISolidFactory.Subtract(bool_list, result_list)
			## Assign the result of subtraction to column tag
			dictionaries[index_pcylaz1_4]['ELEM_TAG'] = result_list[0]
		else:
			return 0
		
	return 0
