import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import rll5_0
import rll5_1

def Execute (names, dictionaries):
	global variables
	global params
	global rll5_0_p
	global rll5_1_p

	rll5_0.variables = variables
	rll5_1.variables = variables

	params = variables['PARAM_NG_a_rll5']
	rll5_0_p = variables['PARAM_NG_rll5_0']
	rll5_1_p = variables['PARAM_NG_rll5_1']

	## use the following variable to use rll5_0  position
	rll5_0_pos = rll5_0_p['POSITION']
	## use the following variable to use rll5_0  direction
	rll5_0_dir = rll5_0_p['DIRECTION']

	## uncomment following line to disable rll5_0 cavity building
	## rll5_0_p['BUILD_CAVITY'] = 0
	rll5_0.key_name = 'PARAM_NG_rll5_0'
	rll5_0.Execute(names, dictionaries)
	## use the following line to put rll5_0 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use rll5_1  position
	rll5_1_pos = rll5_1_p['POSITION']
	## use the following variable to use rll5_1  direction
	rll5_1_dir = rll5_1_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable rll5_1 cavity building
	## rll5_1_p['BUILD_CAVITY'] = 0
	rll5_1.key_name = 'PARAM_NG_rll5_1'
	rll5_1.Execute(names, dictionaries)
	## use the following line to put rll5_1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
