import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import shim1
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global shim1_p
	global shcsm_p

	shim1.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_shim1']
	shim1_p = variables['PARAM_NG_shim1']
	shcsm_p = variables['PARAM_NG_shcsm']
	
	check_screw = params['CREATE_SCREW']

	## use the following variable to use shim1  position
	shim1_pos = shim1_p['POSITION']
	## use the following variable to use shim1  direction
	shim1_dir = shim1_p['DIRECTION']

	## uncomment following line to disable shim1 cavity building
	## shim1_p['BUILD_CAVITY'] = 0
	shim1.key_name = 'PARAM_NG_shim1'
	shim1.Execute(names, dictionaries)
	## use the following line to put shim1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	
	if check_screw:
		## use the following variable to use shcsm  position
		shcsm_pos = shcsm_p['POSITION']
		## use the following variable to use shcsm  direction
		shcsm_dir = shcsm_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable shcsm cavity building
		## shcsm_p['BUILD_CAVITY'] = 0
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		## use the following line to put shcsm cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
