import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import st3
import shcs1
import shcsml

def Execute (names, dictionaries):
	global variables
	global params
	global st3_p
	global shcs1_p
	global shcsml_p

	st3.variables = variables
	shcs1.variables = variables
	shcsml.variables = variables

	params = variables['PARAM_NG_a_st8']
	st3_p = variables['PARAM_NG_st3']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcsml_p = variables['PARAM_NG_shcsml']

	## use the following variable to use st3  position
	st3_pos = st3_p['POSITION']
	## use the following variable to use st3  direction
	st3_dir = st3_p['DIRECTION']

	## uncomment following line to disable st3 cavity building
	## st3_p['BUILD_CAVITY'] = 0
	st3.key_name = 'PARAM_NG_st3'
	st3.Execute(names, dictionaries)
	## use the following line to put st3 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcs1  position
	shcs1_pos = shcs1_p['POSITION']
	## use the following variable to use shcs1  direction
	shcs1_dir = shcs1_p['DIRECTION']
	#VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],-st3_p['END_THICK']+st3_p['PLAY_START_PLATE']-st3_p['LENGTH']+st3_p['LENGTH_SINK'], shcs1_p['POSITION'])	
	#shcs1_p['START_THICK'] = st3_p['LENGTH'] - st3_p['LENGTH_SINK']
	#shcs1_p['END_THICK'] = st3_p['END_THICK'] - st3_p['PLAY_START_PLATE']
	#shcs1_p['TOTAL_THICK'] = 
	## put additional member contraints

	## uncomment following line to disable shcs1 cavity building
	## shcs1_p['BUILD_CAVITY'] = 0
	## use the following line to put shcs1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
	#shcs1_p['BUILD_CAVITY'] = 0
	
	if params['CHECK_S_BOTTOM']:
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
	
	
	
	#index_shcs1 = dictionaries.__len__()-1
	#start_screw_cavity = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
	#end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
	#dictionaries[index_shcs1]['CAVITY_TAG'] = end_screw_cavity
	if params['CHECK_S_TOP']:
		VISIGeoLib.ProjectPointOntoVector(shcsml_p['POSITION'], shcsml_p['DIRECTION'],st3_p['PLAY_START_PLATE']-st3_p['LENGTH']+st3_p['LENGTH_SINK'], shcsml_p['POSITION'])	
		shcsml_p['CAV_DEL'] = st3_p['LENGTH']-st3_p['LENGTH_SINK']
		shcsml.key_name = 'PARAM_NG_shcsml'
		shcsml.Execute(names, dictionaries)
		
	
	return 0
