import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import tbc1
import tbc2

def Execute (names, dictionaries):
	global variables
	global params
	global tbc1_p
	global tbc2_p

	tbc1.variables = variables
	tbc2.variables = variables

	params = variables['PARAM_NG_a_tbc1']
	tbc1_p = variables['PARAM_NG_tbc1']
	tbc2_p = variables['PARAM_NG_tbc2']

	## use the following variable to use tbc1  position
	tbc1_pos = tbc1_p['POSITION']
	## use the following variable to use tbc1  direction
	tbc1_dir = tbc1_p['DIRECTION']

	## uncomment following line to disable tbc1 cavity building
	## tbc1_p['BUILD_CAVITY'] = 0
	tbc1.key_name = 'PARAM_NG_tbc1'
	tbc1.Execute(names, dictionaries)
	## use the following line to put tbc1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use tbc2  position
	tbc2_pos = tbc2_p['POSITION']
	## use the following variable to use tbc2  direction
	tbc2_dir = tbc2_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable tbc2 cavity building
	## tbc2_p['BUILD_CAVITY'] = 0
	tbc2.key_name = 'PARAM_NG_tbc2'
	tbc2.Execute(names, dictionaries)
	## use the following line to put tbc2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
