import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height10 = params['HEIGHT10']
	height2 = params['HEIGHT2']
	height3 = params['HEIGHT3']
	height4 = params['HEIGHT4']
	length8 = params['LENGTH8']
	chamfer3 = params['CHAMFER3']
	chamfer1 = params['CHAMFER1']
	distance = params['DISTANCE']
	length2 = params['LENGTH2']
	length3 = params['LENGTH3']
	chamfer2 = params['CHAMFER2']
	width5 = params['WIDTH5']
	radius1 = params['RADIUS1']
	radius2 = params['RADIUS2']
	cut = params['CUT']
	length6 = params['LENGTH6']
	length9 = params['LENGTH9']
	diameter1 = params['DIAMETER1']
	diameter2 = params['DIAMETER2']
	diameter_sink1 = params['DIAMETER_SINK1']
	height_sink1 = params['HEIGHT_SINK1']
	height5 = params['HEIGHT5']
	length6_var = params['LENGTH6_VAR']
	length5_var = params['LENGTH5_VAR']
	length4_var = params['LENGTH4_VAR']
	length1_var = params['LENGTH1_VAR']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	start_pos2 = VISIPoint.New()
	start_pos2.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	length = 28./1000+18./1000 +length1_var+length5_var
	length = length-cut
	
		
	if not height10:	
		#Create Body
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length)/2, start_pos)
		bl1 = VISISolidFactory.CreateBlock ((length), width, height3, start_pos, x_axis, direction)
		Uni_list.append(bl1)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width-(width-width5)/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length)/2-(length1_var+(length2-length3)+2*radius2)/2-length6, start_pos)
		
		#Create Groove
		bl2 = VISISolidFactory.CreateBlock (length1_var+(length2-length3)+2*radius2, width, height3, start_pos, x_axis, direction)
		Uni_list.append(bl2)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width-width5, start_pos)
	
		bl21 = VISISolidFactory.CreateBlock (length1_var+(length2-length3)+2*radius2, width, height3, start_pos, x_axis, direction)
		Uni_list.append(bl21)
				
		##Subtract
		VISISolidFactory.Subtract(Uni_list, Uni_list2)
		
		#Blend
		edges = [253,257,115,119]
		VISISolidFactory.BlendEdges(Uni_list2[0], edges, radius2, 1)
		
		edges = [246,242,112,109]
		VISISolidFactory.BlendEdges(Uni_list2[0], edges, radius1, 1)
		
		
		#Create Steps
		start_pos.Set(position.x(), position.y(), position.z())
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(length1_var+60./1000)/2, start_pos)
		bl3 = VISISolidFactory.CreateBlock ((length1_var+60./1000), width, height4, start_pos, x_axis, direction)
		Uni_list2.append(bl3)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length1_var+60./1000)/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(length1_var+length6+length4_var)/2, start_pos)
		bl4 = VISISolidFactory.CreateBlock ((length1_var+length6+length4_var), width, height5+height4, start_pos, x_axis, direction)
		Uni_list2.append(bl4)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length1_var+length6+length4_var)/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(distance)/2, start_pos)
		bl5 = VISISolidFactory.CreateBlock ((distance), width, chamfer2+height5+height4, start_pos, x_axis, direction)
		Uni_list2.append(bl5)
		
		##Subtract
		VISISolidFactory.Subtract(Uni_list2, Uni_list3)
		
		#Chamfer
		edges = [832,823]
		VISISolidFactory.ChamferEdges(Uni_list3[0], edges, chamfer3,chamfer3, 1)
		
		#Chamfer
		edges = [1284,1290]
		VISISolidFactory.ChamferEdges(Uni_list3[0], edges, chamfer1,chamfer1, 1)
		
	
		#Create Holes
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length8), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, (height3), start_pos)
		
		cyl1 = VISISolidFactory.CreateCylinder (diameter_sink1/2, height_sink1, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl1)
		
		cyl2 = VISISolidFactory.CreateCylinder (diameter1/2, height3, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl2)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length5_var-length4_var), start_pos)
		
		cyl3 = VISISolidFactory.CreateCylinder (diameter_sink1/2, height_sink1, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl3)
		
		cyl4 = VISISolidFactory.CreateCylinder (diameter1/2, height3, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl4)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length9/2), start_pos)
				
		cyl5 = VISISolidFactory.CreateCylinder (diameter2/2, height3, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl5)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (-length9), start_pos)
				
		cyl6 = VISISolidFactory.CreateCylinder (diameter2/2, height3, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl6)
		
		##Subtract
		VISISolidFactory.Subtract(Uni_list3, Result_List)
		
	else:
		#Create Body
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length9)/2, start_pos)
		bl1 = VISISolidFactory.CreateBlock (length9, width, height3, start_pos, x_axis, direction)
		Uni_list.append(bl1)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length9)/2, start_pos)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height3, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length5_var-length9-(length2-length3)/2-radius2)/2, start_pos)
		bl2 = VISISolidFactory.CreateBlock (length5_var-length9-(length2-length3)/2-radius2, width, height3-height4, start_pos, x_axis, inv_dir)
		Uni_list.append(bl2)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length5_var-length9-(length2-length3)/2-radius2)/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length2-length3+2*radius2)/2, start_pos)
		bl3 = VISISolidFactory.CreateBlock (length2-length3+2*radius2, width5, height3-height4, start_pos, x_axis, inv_dir)
		Uni_list.append(bl3)
	
		special_l = length6-(length2-length3)/2-radius2
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (special_l)/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length2-length3+2*radius2)/2, start_pos)
		bl4 = VISISolidFactory.CreateBlock (special_l, width, height3-height4, start_pos, x_axis, inv_dir)
		Uni_list.append(bl4)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (special_l)/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length8)/2, start_pos)
		bl5 = VISISolidFactory.CreateBlock (length8, width, height10, start_pos, x_axis, inv_dir)
		Uni_list.append(bl5)
		
		edges = [18,20,6,25]
		VISISolidFactory.ChamferEdges(bl5, edges, chamfer1,chamfer1, 1)
		
		##Unite
		VISISolidFactory.Unite(Uni_list, Result_List)

		#Blend
		edges = [79,98,109,95]
		VISISolidFactory.BlendEdges(Result_List[0], edges, radius2, 1)
		
		#Blend
		edges = [111,93,102,82]
		VISISolidFactory.BlendEdges(Result_List[0], edges, radius1, 1)
		
		
		# edges = [31]
		# VISISolidFactory.ChamferEdges(bl1, edges, chamfer3,chamfer3, 1)

		# VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length-length2-radius2)/2, start_pos)
		# VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length2-length3+2*radius2)/2, start_pos)
		# bl2 = VISISolidFactory.CreateBlock (length2-length3+2*radius2, width5, height10, start_pos, x_axis, direction)
		# Uni_list.append(bl2)
		
		# VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length2-length3+2*radius2)/2, start_pos)
		# VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length3-radius2)/2, start_pos)
		# bl3 = VISISolidFactory.CreateBlock ((length3-radius2), width, height10, start_pos, x_axis, direction)
		# Uni_list.append(bl3)
		
		# edges = [18,20]
		# VISISolidFactory.ChamferEdges(bl3, edges, chamfer2,chamfer2, 1)
		
		# ##Unite
		# VISISolidFactory.Unite(Uni_list, Uni_list2)
		
		
		# #Blend
		# edges = [146,159,143,140]
		# VISISolidFactory.BlendEdges(Uni_list2[0], edges, radius2, 1)
		
		# edges = [20,164,18,150]
		# VISISolidFactory.BlendEdges(Uni_list2[0], edges, radius1, 1)
		
		# #Create Groove
		# start_pos.Set(position.x(), position.y(), position.z())
		# VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height10-height9, start_pos)
		# VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length-length8)/2, start_pos)
		# bl11 = VISISolidFactory.CreateBlock (length-length8, width, height10-height9, start_pos, x_axis, direction)
		# Uni_list2.append(bl11)
		
		# ##Subtract
		# VISISolidFactory.Subtract(Uni_list2, Result_List)
		
		VISISolidFactory.RotateBody (Result_List[0], start_pos2, direction, math.radians(180))
		
	## return the tag of created element, 0 if no element
	#VISISolidFactory.TranslateBodyByVector(Result_List[0], ref_direction, cut)
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height10 = params['HEIGHT10']
	height2 = params['HEIGHT2']
	height3 = params['HEIGHT3']
	height4 = params['HEIGHT4']
	length8 = params['LENGTH8']
	chamfer3 = params['CHAMFER3']
	chamfer1 = params['CHAMFER1']
	distance = params['DISTANCE']
	length2 = params['LENGTH2']
	length3 = params['LENGTH3']
	chamfer2 = params['CHAMFER2']
	width5 = params['WIDTH5']
	radius1 = params['RADIUS1']
	radius2 = params['RADIUS2']
	cut = params['CUT']
	length6 = params['LENGTH6']
	length9 = params['LENGTH9']
	diameter1 = params['DIAMETER1']
	diameter2 = params['DIAMETER2']
	diameter_sink1 = params['DIAMETER_SINK1']
	height_sink1 = params['HEIGHT_SINK1']
	height5 = params['HEIGHT5']
	length6_var = params['LENGTH6_VAR']
	length5_var = params['LENGTH5_VAR']
	length4_var = params['LENGTH4_VAR']
	length1_var = params['LENGTH1_VAR']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_llcp2_7'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
