import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, VISIParam
variables = 0
params = 0
import ll21_0
import ll21_1
import ll21_2
import shcs1
import dp1
import shcs3


def Execute (names, dictionaries):
	global variables
	global params
	global ll21_0_p
	global ll21_1_p
	global ll21_2_p
	global shcs1_p
	global shcs1_1_p
	global shcs1_2_p
	global shcs1_3_p
	global shcs1_4_p
	#global dp1_p
	#global dp1_1_p
	global dp1_2_p
	global shcs3_p

	ll21_0.variables = variables
	ll21_1.variables = variables
	ll21_2.variables = variables
	shcs1.variables = variables
	dp1.variables = variables
	shcs3.variables = variables

	params = variables['PARAM_NG_a_ll21']
	ll21_0_p = variables['PARAM_NG_ll21_0']
	ll21_1_p = variables['PARAM_NG_ll21_1']
	ll21_2_p = variables['PARAM_NG_ll21_2']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']
	shcs1_2_p = variables['PARAM_NG_shcs1_2']
	shcs1_3_p = variables['PARAM_NG_shcs1_3']
	shcs1_4_p = variables['PARAM_NG_shcs1_4']
	#dp1_p = variables['PARAM_NG_dp1']
	#dp1_1_p = variables['PARAM_NG_dp1_1']
	dp1_2_p = variables['PARAM_NG_dp1_2']
	shcs3_p = variables['PARAM_NG_shcs3']
	
	## use the following variable to use ll21_0  position
	ll21_0_pos = ll21_0_p['POSITION']
	ll21_0_dir = ll21_0_p['DIRECTION']

	## uncomment following line to disable ll21_0 cavity building
	#ll21_0_p['BUILD_CAVITY'] = 0
	ll21_0.key_name = 'PARAM_NG_ll21_0'
	ll21_0.Execute(names, dictionaries)
	index_ll21_0 = dictionaries.__len__()-1
	element_ll21_0 = dictionaries[index_ll21_0]['ELEM_TAG']
	
	## use the following variable to use ll21_1  position
	ll21_1_pos = ll21_1_p['POSITION']
	## use the following variable to use ll21_1  direction
	ll21_1_dir = ll21_1_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable ll21_1 cavity building
	## ll21_1_p['BUILD_CAVITY'] = 0
	ll21_1.key_name = 'PARAM_NG_ll21_1'
	ll21_1.Execute(names, dictionaries)
	index_ll21_1 = dictionaries.__len__()-1
	element_ll21_1 = dictionaries[index_ll21_1]['ELEM_TAG']
	## use the following line to put ll21_1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use ll21_2  position
	ll21_2_pos = ll21_2_p['POSITION']
	## use the following variable to use ll21_2  direction
	ll21_2_dir = ll21_2_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable ll21_2 cavity building
	## ll21_2_p['BUILD_CAVITY'] = 0
	ll21_2.key_name = 'PARAM_NG_ll21_2'
	ll21_2.Execute(names, dictionaries)
	index_ll21_2 = dictionaries.__len__()-1
	element_ll21_2 = dictionaries[index_ll21_2]['ELEM_TAG']
	## use the following line to put ll21_2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag


	#Screw 1
	shcs1_p['BUILD_CAVITY'] = 0
	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
	shcs1_p['START_PLATE'] = element_ll21_0
	index_shcs1 = dictionaries.__len__()-1
	start_screw_shcs1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
	end_screw_shcs1 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
	dictionaries[index_shcs1]['CAVITY_TAG'] = end_screw_shcs1
	
	#Screw 1 1
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], params['ARBIT_AXIS'], -ll21_0_p['BLOCK_SCREW_DISTANCE_BETWEEN'], shcs1_p['POSITION'])

	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
	index_shcs11 = dictionaries.__len__()-1
	start_screw_shcs11 = shcs1.CreateStartPlateHole(dictionaries[index_shcs11]['ELEM_TAG'])
	end_screw_shcs11 = shcs1.CreateEndPlateHole(dictionaries[index_shcs11]['ELEM_TAG'])
	dictionaries[index_shcs11]['CAVITY_TAG'] = end_screw_shcs11
	
	#Screw 3
	## put additional member contraints

	VISIGeoLib.ProjectPointOntoVector(shcs1_2_p['POSITION'], params['ARBIT_AXIS'], -ll21_0_p['ARM_WIDTH']/2+ll21_0_p['STOP_WIDTH']/2-0.25/1000, shcs1_2_p['POSITION'])
	
	shcs1_2_p['BUILD_CAVITY'] = 0
	shcs1_2_p['START_PLATE'] = element_ll21_0
	shcs1.key_name = 'PARAM_NG_shcs1_2'
	shcs1.Execute(names, dictionaries)
	index_shcs1_2 = dictionaries.__len__()-1
	start_screw_shcs1_2 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_2]['ELEM_TAG'])
	end_screw_shcs1_2 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_2]['ELEM_TAG'])
	dictionaries[index_shcs1_2]['CAVITY_TAG'] = end_screw_shcs1_2
	
	if ll21_0_p['STOP_SCREW_DISTANCE_WIDTH']>0:
		VISIGeoLib.ProjectPointOntoVector(shcs1_2_p['POSITION'], params['ARBIT_AXIS'], -ll21_0_p['STOP_SCREW_DISTANCE_WIDTH'], shcs1_2_p['POSITION'])
		shcs1.key_name = 'PARAM_NG_shcs1_2'
		shcs1.Execute(names, dictionaries)
		index_shcs1_2_1 = dictionaries.__len__()-1
		start_screw_shcs1_2_1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_2_1]['ELEM_TAG'])
		end_screw_shcs1_2_1 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_2_1]['ELEM_TAG'])
		dictionaries[index_shcs1_2_1]['CAVITY_TAG'] = end_screw_shcs1_2_1
		
	VISIGeoLib.ProjectPointOntoVector(shcs1_2_p['POSITION'], params['ARBIT_AXIS'], -2*(-ll21_0_p['ARM_WIDTH']/2+ll21_0_p['STOP_WIDTH']/2-0.25/1000)+ll21_0_p['STOP_SCREW_DISTANCE_WIDTH'], shcs1_2_p['POSITION'])
	
	shcs1_2_p['BUILD_CAVITY'] = 0
	shcs1_2_p['START_PLATE'] = element_ll21_0
	shcs1.key_name = 'PARAM_NG_shcs1_2'
	shcs1.Execute(names, dictionaries)
	index_shcs1_21 = dictionaries.__len__()-1
	start_screw_shcs1_21 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_21]['ELEM_TAG'])
	end_screw_shcs1_21 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_21]['ELEM_TAG'])
	dictionaries[index_shcs1_21]['CAVITY_TAG'] = end_screw_shcs1_21
	
	if ll21_0_p['STOP_SCREW_DISTANCE_WIDTH']>0:
		VISIGeoLib.ProjectPointOntoVector(shcs1_2_p['POSITION'], params['ARBIT_AXIS'], -ll21_0_p['STOP_SCREW_DISTANCE_WIDTH'], shcs1_2_p['POSITION'])
		shcs1.key_name = 'PARAM_NG_shcs1_2'
		shcs1.Execute(names, dictionaries)
		index_shcs1_21_1 = dictionaries.__len__()-1
		start_screw_shcs1_21_1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_21_1]['ELEM_TAG'])
		end_screw_shcs1_21_1 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_21_1]['ELEM_TAG'])
		dictionaries[index_shcs1_21_1]['CAVITY_TAG'] = end_screw_shcs1_21_1

	#Screw 4
	## put additional member contraints

	shcs1_3_p['BUILD_CAVITY'] = 0
	shcs1_3_p['START_PLATE'] = element_ll21_1
	shcs1.key_name = 'PARAM_NG_shcs1_3'
	shcs1.Execute(names, dictionaries)
	index_shcs1_3 = dictionaries.__len__()-1
	start_screw_shcs1_3 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_3]['ELEM_TAG'])
	end_screw_shcs1_3 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_3]['ELEM_TAG'])
	dictionaries[index_shcs1_3]['CAVITY_TAG'] = end_screw_shcs1_3
	
	VISIGeoLib.ProjectPointOntoVector(shcs1_3_p['POSITION'], ll21_0_p['DIRECTION'], ll21_1_p['SCREW2_DISTANCE']-ll21_1_p['SCREW_DISTANCE'], shcs1_3_p['POSITION'])
	shcs1.key_name = 'PARAM_NG_shcs1_3'
	shcs1.Execute(names, dictionaries)
	index_shcs1_31 = dictionaries.__len__()-1
	start_screw_shcs1_31 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_31]['ELEM_TAG'])
	end_screw_shcs1_31 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_31]['ELEM_TAG'])
	dictionaries[index_shcs1_31]['CAVITY_TAG'] = end_screw_shcs1_31
	
	


	#Screw 5
	## put additional member contraints

	if ll21_0_p['TYPE'] > 0:
		shcs1_4_p['BUILD_CAVITY'] = 0
		shcs1_4_p['START_PLATE'] = element_ll21_2
		shcs1.key_name = 'PARAM_NG_shcs1_4'
		shcs1.Execute(names, dictionaries)
		index_shcs1_4 = dictionaries.__len__()-1
		start_screw_shcs1_4 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_4]['ELEM_TAG'])
		end_screw_shcs1_4 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_4]['ELEM_TAG'])

		if ll21_2_p['DISTANCE_BETWEEN_SCREWS']:
			VISIGeoLib.ProjectPointOntoVector(shcs1_4_p['POSITION'], ll21_0_p['DIRECTION'], ll21_2_p['DISTANCE_BETWEEN_SCREWS'], shcs1_4_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1_4'
			shcs1.Execute(names, dictionaries)
			index_shcs1_4_1 = dictionaries.__len__()-1
			start_screw_shcs1_4_1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_4_1]['ELEM_TAG'])
			end_screw_shcs1_4_1 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_4_1]['ELEM_TAG'])
	else:
		shcs3_p['BUILD_CAVITY'] = 0
		shcs3_p['START_PLATE'] = element_ll21_2
		shcs3_p['END_PLATE'] = element_ll21_1
		shcs3.key_name = 'PARAM_NG_shcs3'
		shcs3.Execute(names, dictionaries)
		index_shcs3 = dictionaries.__len__()-1
		start_screw_shcs3 = shcs3.CreateStartPlateHole(dictionaries[index_shcs3]['ELEM_TAG'])
		end_screw_shcs3 = shcs3.CreateEndPlateHole(dictionaries[index_shcs3]['ELEM_TAG'])
		
		if ll21_2_p['DISTANCE_BETWEEN_SCREWS']:
			VISIGeoLib.ProjectPointOntoVector(shcs3_p['POSITION'], ll21_0_p['DIRECTION'], ll21_2_p['DISTANCE_BETWEEN_SCREWS'], shcs3_p['POSITION'])
			shcs3.key_name = 'PARAM_NG_shcs3'
			shcs3.Execute(names, dictionaries)
			index_shcs3_1 = dictionaries.__len__()-1
			start_screw_shcs3_1 = shcs3.CreateStartPlateHole(dictionaries[index_shcs3_1]['ELEM_TAG'])
			end_screw_shcs3_1 = shcs3.CreateEndPlateHole(dictionaries[index_shcs3_1]['ELEM_TAG'])
			
	
	#dp1_2_p['BUILD_CAVITY'] = 0
	dp1_2_p['START_PLATE'] = element_ll21_2
	dp1_2_p['END_PLATE'] = element_ll21_1
	dp1.key_name = 'PARAM_NG_dp1_2'
	dp1.Execute(names, dictionaries)
	index_dp1_2 = dictionaries.__len__()-1
	cav_dp1_2 = dictionaries[index_dp1_2]['CAVITY_TAG']

	dp1.key_name = 'PARAM_NG_dp1_2'
	dp1.Execute(names, dictionaries)
	index_dp1_21 = dictionaries.__len__()-1
	cav_dp1_21 = dictionaries[index_dp1_21]['CAVITY_TAG']
	
	
	#Subtract
	Uni_List = []
	Result_List = []
	Uni_List.append(element_ll21_0)
	Uni_List.append(start_screw_shcs1)
	Uni_List.append(start_screw_shcs11)
	#Uni_List.append(cav_screw_shcs1_1)
	
		
	#Cut Screw Cavity 1
	Front_Body_List = []
	Back_Body_List = []
	VISISolidFactory.CutWithPlane(ll21_0_p['POSITION'], ll21_0_p['DIRECTION'], start_screw_shcs1_2, Front_Body_List, Back_Body_List)
	if len(Front_Body_List)>0:
		start_screw_shcs1_2 = Front_Body_List[0]
		#Delete 
		part4 = Back_Body_List[0]
		del_list = [part4]
		VISISolidFactory.DeleteBodies(del_list)
		#Append to UniList
		Uni_List.append(start_screw_shcs1_2)
	else:
		Uni_List.append(start_screw_shcs1_2)
	
	#Cut Screw Cavity 2
	if ll21_0_p['STOP_SCREW_DISTANCE_WIDTH']>0:
		Front_Body_List = []
		Back_Body_List = []
		VISISolidFactory.CutWithPlane(ll21_0_p['POSITION'], ll21_0_p['DIRECTION'], start_screw_shcs1_2_1, Front_Body_List, Back_Body_List)
		if len(Front_Body_List)>0:
			start_screw_shcs1_2_1 = Front_Body_List[0]
			#Delete 
			part4 = Back_Body_List[0]
			del_list = [part4]
			VISISolidFactory.DeleteBodies(del_list)
			Front_Body_List = []
			Back_Body_List = []
			#Append to UniList
			Uni_List.append(start_screw_shcs1_2_1)
		else:
			Uni_List.append(start_screw_shcs1_2_1)
			
			
	#Cut Screw Cavity 1
	Front_Body_List = []
	Back_Body_List = []
	VISISolidFactory.CutWithPlane(ll21_0_p['POSITION'], ll21_0_p['DIRECTION'], start_screw_shcs1_21, Front_Body_List, Back_Body_List)
	if len(Front_Body_List)>0:
		start_screw_shcs1_21 = Front_Body_List[0]
		#Delete 
		part4 = Back_Body_List[0]
		del_list = [part4]
		VISISolidFactory.DeleteBodies(del_list)
		#Append to UniList
		Uni_List.append(start_screw_shcs1_21)
	else:
		Uni_List.append(start_screw_shcs1_21)
	
	#Cut Screw Cavity 2
	if ll21_0_p['STOP_SCREW_DISTANCE_WIDTH']>0:
		Front_Body_List = []
		Back_Body_List = []
		VISISolidFactory.CutWithPlane(ll21_0_p['POSITION'], ll21_0_p['DIRECTION'], start_screw_shcs1_21_1, Front_Body_List, Back_Body_List)
		if len(Front_Body_List)>0:
			start_screw_shcs1_21_1 = Front_Body_List[0]
			#Delete 
			part4 = Back_Body_List[0]
			del_list = [part4]
			VISISolidFactory.DeleteBodies(del_list)
			Front_Body_List = []
			Back_Body_List = []
			#Append to UniList
			Uni_List.append(start_screw_shcs1_21_1)
		else:
			Uni_List.append(start_screw_shcs1_21_1)
	
	VISISolidFactory.Subtract(Uni_List, Result_List)
	dictionaries[index_ll21_0]['ELEM_TAG'] = Result_List[0]
	#dictionaries[index_shcs1_1]['CAVITY_TAG'] = 0
	
	
	#Subtract
	Uni_List = []
	Result_List = []
	Uni_List.append(element_ll21_1)
	Uni_List.append(start_screw_shcs1_3)
	Uni_List.append(start_screw_shcs1_31)
	Uni_List.append(cav_dp1_21)
	if ll21_0_p['TYPE'] > 0:
		Uni_List.append(end_screw_shcs1_4)
		if ll21_2_p['DISTANCE_BETWEEN_SCREWS']:
			Uni_List.append(end_screw_shcs1_4_1)
	else:
		Uni_List.append(end_screw_shcs3)
		if ll21_2_p['DISTANCE_BETWEEN_SCREWS']:
			Uni_List.append(end_screw_shcs3_1)
			
	VISISolidFactory.Subtract(Uni_List, Result_List)
	dictionaries[index_ll21_1]['ELEM_TAG'] = Result_List[0]
	dictionaries[index_dp1_21]['CAVITY_TAG'] = 0
	
	if ll21_0_p['TYPE'] > 0:
		dictionaries[index_shcs1_4]['CAVITY_TAG'] = 0
		if ll21_2_p['DISTANCE_BETWEEN_SCREWS']:
			dictionaries[index_shcs1_4_1]['CAVITY_TAG'] = 0
	else:
		dictionaries[index_shcs3]['CAVITY_TAG'] = 0
		if ll21_2_p['DISTANCE_BETWEEN_SCREWS']:
			dictionaries[index_shcs3_1]['CAVITY_TAG'] = 0
	
	#Subtract
	Uni_List = []
	Result_List = []
	Uni_List.append(element_ll21_2)
	Uni_List.append(cav_dp1_2)
	if ll21_0_p['TYPE'] > 0:
		Uni_List.append(start_screw_shcs1_4)
		if ll21_2_p['DISTANCE_BETWEEN_SCREWS']:
			Uni_List.append(start_screw_shcs1_4_1)
	else:
		Uni_List.append(start_screw_shcs3)
		if ll21_2_p['DISTANCE_BETWEEN_SCREWS']:
			Uni_List.append(start_screw_shcs3_1)
	
	VISISolidFactory.Subtract(Uni_List, Result_List)
	dictionaries[index_ll21_2]['ELEM_TAG'] = Result_List[0]
	dictionaries[index_dp1_2]['CAVITY_TAG'] = 0
	return 0
