import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import bc1_3
import jr3

def Execute (names, dictionaries):
	global variables
	global params
	global bc1_3_p
	global jr3_p

	bc1_3.variables = variables
	jr3.variables = variables

	params = variables['PARAM_NG_a_bgb5_2']
	bc1_3_p = variables['PARAM_NG_bc1_3']
	jr3_p = variables['PARAM_NG_jr3']

	## use the following variable to use bc1_3  position
	bc1_3_pos = bc1_3_p['POSITION']
	## use the following variable to use bc1_3  direction
	bc1_3_dir = bc1_3_p['DIRECTION']

	## uncomment following line to disable bc1_3 cavity building
	## bc1_3_p['BUILD_CAVITY'] = 0
	bc1_3.key_name = 'PARAM_NG_bc1_3'
	bc1_3.Execute(names, dictionaries)
	## use the following line to put bc1_3 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
	
	VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bc1_3_p['DIRECTION'], -bc1_3_p['OFFSET'], jr3_p['POSITION'])
	
	if bc1_3_p['REVERSE_ELEMENT']:
		VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], jr3_p['DIRECTION'], bc1_3_p['DISTANCE_GROOVE']-bc1_3_p['WIDTH_GROOVE'], jr3_p['POSITION'])
	else:
		VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], jr3_p['DIRECTION'], bc1_3_p['LENGTH']-bc1_3_p['DISTANCE_GROOVE'], jr3_p['POSITION'])
	if bc1_3_p['INVERT_ELEMENT']:
		VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bc1_3_p['DIRECTION'], bc1_3_p['PLATE_THICK']-bc1_3_p['LENGTH'], jr3_p['POSITION'])
	
	## use the following variable to use jr3  position
	jr3_pos = jr3_p['POSITION']
	## use the following variable to use jr3  direction
	jr3_dir = jr3_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable jr3 cavity building
	## jr3_p['BUILD_CAVITY'] = 0
	jr3.key_name = 'PARAM_NG_jr3'
	jr3.Execute(names, dictionaries)
	## use the following line to put jr3 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
