import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
import lifterpin7
import liftercoup7
import liftergib7

def Execute (names, dictionaries):
	global variables
	global params
	global lifterpin7_p
	global liftercoup7_p
	global liftergib7_p

	lifterpin7.variables = variables
	liftercoup7.variables = variables
	liftergib7.variables = variables

	params = variables['PARAM_NG_a_lifter7']
	lifterpin7_p = variables['PARAM_NG_lifterpin7']
	liftercoup7_p = variables['PARAM_NG_liftercoup7']
	liftergib7_p = variables['PARAM_NG_liftergib7']

	lifterpin7_pos = lifterpin7_p['POSITION']
	lifterpin7_dir = lifterpin7_p['DIRECTION']
        lifterpin7_end_thick = lifterpin7_p['END_THICK']
	lifterpin7.key_name = 'PARAM_NG_lifterpin7'
	lifterpin7.Execute(names, dictionaries)
	
	liftercoup7_pos = liftercoup7_p['POSITION']
	liftercoup7_dir = liftercoup7_p['DIRECTION']
        liftercoup7_housing_height = liftercoup7_p['HOUSING_HEIGHT']
	liftercoup7.key_name = 'PARAM_NG_liftercoup7'
	liftercoup7.Execute(names, dictionaries)
	
	liftergib7_pos = liftergib7_p['POSITION']
	liftergib7_dir = liftergib7_p['DIRECTION']
        liftergib7_ref_dir = liftergib7_p['REF_DIRECTION']
	lifter_height = liftergib7_p['LIFTER_HEIGHT']
	lifter_incl_angle = liftergib7_p['LIFTER_INCL_ANGLE']
	lifter_base_height = liftergib7_p['LIFTER_BASE_HEIGHT']
	lifter_final_part_length = liftergib7_p['LIFTER_FINAL_PART_LENGTH']
	lifter_base_radius = liftergib7_p['LIFTER_BASE_RADIUS']
	coup_height = liftergib7_p['COUP_HEIGHT']
	base_height = liftergib7_p['BASE_HEIGHT']
	liftergib7.key_name = 'PARAM_NG_liftergib7'
	liftergib7.Execute(names, dictionaries)

	#trasl_dist1 = ((lifter_height / math.cos(lifter_incl_angle)) + ((lifter_base_height / math.cos(lifter_incl_angle)) +  lifter_final_part_length/2 * math.tan(math.acos((lifter_final_part_length/2)/lifter_base_radius)))) * math.tan(-lifter_incl_angle)
	trasl_dist1 = -(lifter_height+lifter_base_height+lifter_base_radius) * math.tan(lifter_incl_angle)
	
