import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import lp2
import pbcs_bc
import ball_cage

def Execute (names, dictionaries):
	global variables
	global params
	global lp2_p
	global pbcs_bc_p
	global ball_cage_p

	lp2.variables = variables
	pbcs_bc.variables = variables
	ball_cage.variables = variables

	params = variables['PARAM_NG_a_lppb1_bc_1']
	lp2_p = variables['PARAM_NG_lp2']
	pbcs_bc_p = variables['PARAM_NG_pbcs_bc']
	ball_cage_p = variables['PARAM_NG_ball_cage']

	## use the following variable to use lp2  position
	lp2_pos = lp2_p['POSITION']
	## use the following variable to use lp2  direction
	lp2_dir = lp2_p['DIRECTION']

	## uncomment following line to disable lp2 cavity building
	## lp2_p['BUILD_CAVITY'] = 0
	lp2.key_name = 'PARAM_NG_lp2'
	lp2.Execute(names, dictionaries)
	## use the following line to put lp2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use pbcs_bc  position
	pbcs_bc_pos = pbcs_bc_p['POSITION']
	## use the following variable to use pbcs_bc  direction
	pbcs_bc_dir = pbcs_bc_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable pbcs_bc cavity building
	## pbcs_bc_p['BUILD_CAVITY'] = 0
	pbcs_bc.key_name = 'PARAM_NG_pbcs_bc'
	pbcs_bc.Execute(names, dictionaries)
	## use the following line to put pbcs_bc cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use ball_cage  position
	ball_cage_pos = ball_cage_p['POSITION']
	## use the following variable to use ball_cage  direction
	ball_cage_dir = ball_cage_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable ball_cage cavity building
	## ball_cage_p['BUILD_CAVITY'] = 0
	ball_cage.key_name = 'PARAM_NG_ball_cage'
	ball_cage.Execute(names, dictionaries)
	## use the following line to put ball_cage cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
