import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import pcylaz7_1
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global pcylaz7_1_p
	global shcs1_p

	pcylaz7_1.variables = variables
	shcs1.variables = variables
	
	params = variables['PARAM_NG_a_pcylaz3_1']
	pcylaz7_1_p = variables['PARAM_NG_pcylaz7_1']
	shcs1_p = variables['PARAM_NG_shcs1']

	without_fixing = params['WITHOUT_FIXING']
	pcylaz7_1_pos = pcylaz7_1_p['POSITION']
	pcylaz7_1_dir = pcylaz7_1_p['DIRECTION']
	pcylaz7_1.key_name = 'PARAM_NG_pcylaz7_1'
	pcylaz7_1.Execute(names, dictionaries)
	index_pcylaz7_1 = dictionaries.__len__()-1
	pcylaz7_1_tag = dictionaries[index_pcylaz7_1]['ELEM_TAG']

	i=0

	if(not(without_fixing)):
	#Create a screw until the final amount is reached
		while i < pcylaz7_1_p['NSCREW']:
			shcs1_p['POSITION'] = pcylaz7_1.screw_positions[i]
			shcs1_p['BUILD_CAVITY'] = 0
			shcs1_p['key_name'] = 'shcs1'
			shcs1.Execute(names, dictionaries)
			index_shcs1 = dictionaries.__len__()-1
			start_screw_cavity = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			i = i + 1
			dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity
			#Subtract Screws of Spring to get cavities
			bool_list = []
			result_list = []
			bool_list.append(pcylaz7_1_tag)
			bool_list.append(end_screw_cavity)
			VISISolidFactory.Subtract(bool_list, result_list,0)
			## Assign the result of subtraction to column tag
			dictionaries[index_pcylaz7_1]['ELEM_TAG'] = result_list[0]
		else:
			return 0
		
	return 0
