import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import rbb3_2
import jr3_ex

def Execute (names, dictionaries):
	global variables
	global params
	global rbb3_2_p
	global jr3_ex_p

	rbb3_2.variables = variables
	jr3_ex.variables = variables

	params = variables['PARAM_NG_a_rbb3_2']
	rbb3_2_p = variables['PARAM_NG_rbb3_2']
	jr3_ex_p = variables['PARAM_NG_jr3_ex']

	## use the following variable to use rbb3_2  position
	rbb3_2_pos = rbb3_2_p['POSITION']
	## use the following variable to use rbb3_2  direction
	rbb3_2_dir = rbb3_2_p['DIRECTION']

	## uncomment following line to disable rbb3_2 cavity building
	## rbb3_2_p['BUILD_CAVITY'] = 0
	rbb3_2.key_name = 'PARAM_NG_rbb3_2'
	rbb3_2.Execute(names, dictionaries)
	## use the following line to put rbb3_2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use jr3_ex  position
	jr3_ex_pos = jr3_ex_p['POSITION']
	## use the following variable to use jr3_ex  direction
	jr3_ex_dir = jr3_ex_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable jr3_ex cavity building
	## jr3_ex_p['BUILD_CAVITY'] = 0
	jr3_ex.key_name = 'PARAM_NG_jr3_ex'
	jr3_ex.Execute(names, dictionaries)
	## use the following line to put jr3_ex cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
